VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Create 997 Acknowledgment"
   ClientHeight    =   2385
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4545
   LinkTopic       =   "Form1"
   ScaleHeight     =   2385
   ScaleWidth      =   4545
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtSEFfile 
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Text            =   "850_X12-4010.SEF"
      Top             =   1200
      Width           =   4095
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   375
      Left            =   2520
      TabIndex        =   3
      Top             =   1680
      Width           =   1095
   End
   Begin VB.TextBox txtEDIfile 
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Text            =   "850.x12"
      Top             =   480
      Width           =   4095
   End
   Begin VB.CommandButton cmdTranslate 
      Caption         =   "Translate"
      Height          =   375
      Left            =   960
      TabIndex        =   0
      Top             =   1680
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "SEF File:"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   960
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "EDI File:"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   240
      Width           =   3255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdClose_Click()
    
    Unload Me
    
End Sub

Private Sub cmdTranslate_Click()
    Dim oEdiDoc As Fredi.ediDocument
    Dim oAck As Fredi.ediAcknowledgment
    Dim oSegment As Fredi.ediDataSegment
    Dim oIsa As Fredi.ediDataSegment
    Dim oSchemas As Fredi.ediSchemas
    Dim sSefFile As String
    Dim sEdiFile As String
    Dim sAckfile As String
    Dim spath As String
    
    cmdTranslate.Enabled = False
    Me.MousePointer = vbHourglass
    
    spath = App.Path & "\"
    
    sEdiFile = spath & txtEDIfile.Text
    sSefFile = txtSEFfile.Text
    sAckfile = spath & "997_" & Trim(txtEDIfile.Text)
    
    Set oEdiDoc = New Fredi.ediDocument
    
    'To support large EDI files without consuming much memory
    oEdiDoc.CursorType = Cursor_ForwardOnly
    
    'By default, FREDI uses the  universal coordinated time (UTC), however you can change it to local time
    oEdiDoc.Option(OptDocument_UseLocalTime) = 1
    
    'Stops FREDI from using the internal standard reference
    Set oSchemas = oEdiDoc.GetSchemas
    oSchemas.EnableStandardReference = False
    
    'Load the SEf file for EDI file
    If Len(Trim(sSefFile)) > 0 Then
        oEdiDoc.LoadSchema spath & sSefFile, 0
    End If
    
    'Load SEF file for 997 EDI file
    oEdiDoc.LoadSchema spath & "997_4010.SEF", 0
    
    Set oAck = oEdiDoc.GetAcknowledgment
    
    'Set starting point of EDI Ack control numbers
    oAck.Property(PropertyAck_StartInterchangeControlNum) = 1010
    oAck.Property(PropertyAck_StartGroupControlNum) = 10
    oAck.Property(PropertyAck_StartTransactionSetControlNum) = 1
    
    'Property that determines whether a 997 acknowledgment is created or not while loading the EDI file.
    oAck.EnableFunctionalAcknowledgment = True
    
    'Property that specifies that the transaction set is accepted even with errors
'    oAck.AcceptSetWithErrors = True

    'Property that specifies that the group set is accepted even with errors
'    oAck.AcceptGroupWithErrors = True
    
    oEdiDoc.LoadEdi sEdiFile
    
    'When the cursor type is set to ForwardOnly, make sure to iterate through all segments to allow FREDI to validate them.
    Set oSegment = oEdiDoc.FirstDataSegment
    Do While Not oSegment Is Nothing
        Set oSegment = oSegment.Next
    Loop
    
    
    'Anything in the oAck object that was automtically generated can be changed before saving to file.
    'Changing the date and time in the ISA segment of the oAck
'    Set oSegment = oAck.GetFirst997DataSegment
'    Set oSegment = oSegment.GetDataSegmentByPos("ISA\ISA")
'    oSegment.DataElementValue(9) = "010101"  ' Change date
'    oSegment.DataElementValue(10) = "110130"  ' Change time
'
'    ''Changing the date and time in the GS segment of the oAck
'    Set oSegment = oSegment.GetDataSegmentByPos("\ISA\GS\GS")
'    oSegment.DataElementValue(4) = "20010101"  ' Change date
'    oSegment.DataElementValue(5) = "110130"     ' Change time
    
    
    'Writes the Acknowledgment
    oAck.Save sAckfile
    
    Me.MousePointer = vbNormal
    MsgBox "Done.  997 Ack file = " & sAckfile
    
    Set oEdiDoc = Nothing
    Set oAck = Nothing
    
End Sub

